{$H-}
{
  Autor: Michael Springwald
  Datum: 27.08.2018

  Der Am2320 ist ein Temperatur und Luftfeuchtigkeit Sensor der über I2C
  angebunden werden kann.

  Diese Variante kann zur Zeit nur mit einer Adresse umgehen.
  Ist fehlen auch noch überprüfungen z.b. wie calcCRC bei "readRegister16"
}

unit avr_sensor_am2320;

interface

uses avr_uart, avr_twi;

const
  am2320Adress = $5C;      // 0
  AM2320_SENSOR_VERSION = $01;

  AM2320_CMD_READREG = $03;
  AM2320_REG_TEMP_H = $02;
  AM2320_REG_HUM_H = $00;

var
  _i2caddr:UInt8 = $5C;

function readTemp():UInt16;
function readHum():UInt16;
function readRegister16(reg:UInt8):UInt16;
//function crc16(buffer:uInt8Array; nBytes:UInt8):UInt16;
procedure delay_ms(time : UInt8);

implementation

procedure delay_ms(time : UInt8);
const
  fcpu = 16000000;
  fmul = 1 * fcpu div 1000000;
label
  loop1, loop2, loop3;
begin
  asm
    ldd r20, time
    loop1:
      ldi r21, fmul
      loop2:  // 1000 * fmul = 1000 * 1 * 8 = 8000 cycles / 8MHz
        ldi r22, 250
        loop3:  // 4 * 250 = 1000 cycles
          nop
          dec r22
          brne loop3
        dec r21
        brne loop2
      dec r20
      brne loop1
  end['r20','r21','r22'];
end;

function readTemp(): UInt16;
begin
  result:=0;
end;

function readHum(): UInt16;
begin
  result:=0;
end;

function readRegister16(reg: UInt8): UInt16;
var
  Buffer: uInt8Array;
  i:Integer;
  ret:UInt16;
begin
  // Aufwecken
  TWIStart((am2320Adress shl 1) or TWI_Write);
  TWIWrite($00);
  TWIStop;
  delay_ms(10);

  // Ein Kommando Senden zum "Lese Register"
  TWIStart((am2320Adress shl 1) or TWI_Write);
  TWIWrite(AM2320_CMD_READREG);
  TWIWrite(reg);
  TWIWrite(2);
  TWIStop;
  delay_ms(2);

//  Hier müsste noch eine Überprüfung vorher hin:

//  2 bytes preamble, 2 bytes data, 2 bytes CRC
//  Wire.requestFrom(_i2caddr, (uint8_t)6);
//  if (Wire.available() != 6)
//  return 0xFFFF;

  TWIStart((am2320Adress shl 1) or TWI_Read);
  for i:=0 to 5 do begin
    buffer[i]:=TWIReadACK;
  end;
  TWIStop;

// Bishierher kommt der Code ohne irgendwo "hängen" zu bleiben
  ret:=buffer[2];
  ret:=ret shl 8;
  ret:=ret or buffer[3];

  result:=ret;
end;

{function crc16(buffer: uInt8Array; nBytes: UInt8): UInt16;
begin
  result:=0;
end;}

end.

