{
  Autor: Michael Springwald
  Datum: Montag, der 27.08.2018

  Test Programm für ein:
  AM2320 Sensor - Mist Temperatur und Luftfeuchtigkeit über I2C
  DS3231 RTC - Hier kann die Aktuelle Uhrzeit und das Aktuelle Datum abgefragt werden
  LCD 2004 - Die Infos von den Sensor und dem RTC kommen hierdrauf

}


program project1;
{$H-}

uses avr_uart, avr_gripo, avr_twi, avr_sensor_am2320, avr_rtc_ds3231, avr_lcd_2004;

const
  dl  = 250000+250000+250000+250000; // ca 2 Sekunden

var
  Digit:String[4]; // Werte der einzelnen Digits

procedure IntToDigit(val: UInt16);
var
  achr: byte;
  leer: boolean;
begin
  Digit[0] := #4; // Der String ist 4 Zeichen lang, inklusive Dezimalpunkt.

  // Zehner
  achr := 0;
  while (val >= 100) do begin
    Dec(val, 100);
    Inc(achr);
    leer := False;
  end;
  if leer then begin
    achr := 16;
  end;
  Digit[1] := Char(achr+ 48);

  // Einer
  achr := 0;
  while (val >= 10) do begin
    Dec(val, 10);
    Inc(achr);
    leer := False;
  end;
  if leer then begin
    achr := 16;
  end;
  Digit[2] := Char(achr+ 48);

  // Dezimalpunkt
  Digit[3] := '.';

  // Zehntel
  achr := 0;
  while (val >= 1) do begin
    Dec(val);
    Inc(achr);
  end;
  Digit[4] := Char(achr+ 48);
end;

var
  Temp, Hum:UInt16;
  S:String;
  rtcTime:Trtc_Time;
  Mylcd:TLCD;
begin
  asm cli end; // Interrupt sperren.
  TWIInit;
  asm sei end; // Interrupt frei geben.

  ModePortB(5,true);
  Temp:=0; Hum:=0;

  Mylcd.Create($25);
  Mylcd.Clear;

  S:='';
  repeat
    rtcTime.mday:=0; rtcTime.mon:=0; rtcTime.year:=0;
    rtcTime.h:=0; rtcTime.m:=0; rtcTime.s:=0;
    rtc_recv(rtcTime);

    // Datum
    // Der Tag im Monat
    Mylcd.setCursor(0,1 );
    str(rtcTime.mday,S);
    if rtcTime.mday <=9 then s:='0'+s;
    Mylcd.Write(S+'.');

    // Der Aktuelle Monat
    str(rtcTime.mon,S);
    if rtcTime.mon<=9 then s:='0'+s;
    Mylcd.Write(S+'.');

    // Das Aktuelle Jahr
    str(rtcTime.year,S);
    Mylcd.Write(S + ' ');

    // Die Aktuelle Stunde
    str(rtcTime.h,S);
    if rtcTime.h<=9 then s:='0'+s;
    Mylcd.Write(S+':');

    // Die Aktuelle Minute
    str(rtcTime.m,S);
    if rtcTime.m<=9 then s:='0'+s;
    Mylcd.Write(S+':');

    // Die Aktuelle Sekunde
    str(rtcTime.s,S);
    if rtcTime.s <=9 then s:='0'+s;
    Mylcd.Write(S);

    // Temperatur und Luftfeuchtigkeit
    Temp:=readRegister16(AM2320_REG_TEMP_H);
    Hum:=readRegister16(AM2320_REG_HUM_H);

    IntToDigit(Temp);
    Mylcd.setCursor(0,3 );
    Mylcd.Write(Digit + ' *C ');

    IntToDigit(Hum);
    Mylcd.Write(Digit+' %');

    mysleep(dl);
  until 1 = 2;

end.
